/*
 *  TOPPERS/FMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Flexible MultiProcessor Kernel
 * 
 *  Copyright (C) 2006-2009 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: mpcore.h 844 2011-07-15 05:00:49Z ertl-honda $
 */

/*
 *  MPCORE Υϡɥ񸻤
 */

#ifndef TOPPERS_MPCORE_H
#define TOPPERS_MPCORE_H

#include <sil.h>

#ifndef TOPPERS_MACRO_ONLY

/*
 *  ץؤΥޥ
 */
#define CP15_CONTROL_READ(x)     Asm("mrc p15, 0, %0, c1, c0, 0":"=r"(x))
#define CP15_CONTROL_WRITE(x)    Asm("mcr p15, 0, %0, c1, c0, 0"::"r"(x))

#define CP15_AUXILIARY_READ(x)   Asm("mrc p15, 0, %0, c1, c0, 1":"=r"(x))
#define CP15_AUXILIARY_WRITE(x)  Asm("mcr p15, 0, %0, c1, c0, 1"::"r"(x))

#define CP15_ICACHE_INVALIDATE()           Asm("mcr p15, 0, %0, c7, c5, 0"::"r"(0))
#if __TARGET_ARCH_ARM == 6
#define CP15_DCACHE_INVALIDATE()           Asm("mcr p15, 0, %0, c7, c6, 0"::"r"(0))
#define CP15_DCACHE_CLEAN_AND_INVALIDATE() Asm("MCR p15, 0, %0, c7, c14, 0"::"r"(0))
#elif __TARGET_ARCH_ARM == 7
#define CP15_DCACHE_INVALIDATE(x)           Asm("mcr p15, 0, %0, c7, c6, 2"::"r"(x))
#define CP15_DCACHE_CLEAN_AND_INVALIDATE(x) Asm("MCR p15, 0, %0, c7, c14, 2"::"r"(x))
#endif /* __TARGET_ARCH_ARM == 7 */

#if __TARGET_ARCH_ARM == 6
#define CP15_PBUFFER_FLUSH()               Asm("mcr p15, 0, %0, c7, c5, 4"::"r"(0):"memory")
#define CP15_DATA_SYNC_BARRIER()           Asm("mcr p15, 0, %0, c7, c10, 4"::"r"(0):"memory")
#define CP15_DATA_MEMORY_BARRIER()         Asm("mcr p15, 0, %0, c7, c10, 5"::"r" (0):"memory")
#elif __TARGET_ARCH_ARM == 7
#define CP15_PBUFFER_FLUSH()               Asm("isb":::"memory")
#define CP15_DATA_SYNC_BARRIER()           Asm("dsb":::"memory")
#define CP15_DATA_MEMORY_BARRIER()         Asm("dmb":::"memory")
#endif /* __TARGET_ARCH_ARM == 7 */

#define CP15_INVALIDATE_UNIFIED_TLB() Asm("mcr p15, 0, %0, c8, c7,  0"::"r"(0))

#define CP15_TTBCR_WRITE(x) Asm("mcr p15, 0, %0, c2, c0, 2"::"r"(x))
#define CP15_TTB0_READ(x)   Asm("mrc p15, 0, %0, c2, c0, 0":"=r"(x))
#define CP15_TTB0_WRITE(x)  Asm("mcr p15, 0, %0, c2, c0, 0"::"r"(x))

#define CP15_DOMAINS_WRITE(x) Asm("mcr p15, 0, %0, c3, c0, 0":: "r"(x))

#define CP15_CPUID_READ(x)     Asm("mrc p15, 0, %0, c0, c0, 5":"=r"(x))

#define CP15_CACHE_SIZE_ID_READ(x)         Asm("mrc p15, 1, %0, c0, c0, 0":"=r"(x))

#if __TARGET_ARCH_ARM == 7
#define CP15_CACHE_SIZE_SELECTION_WRITE(x) Asm("mcr p15, 2, %0, c0, c0, 0"::"r"(x))
#define CP15_CACHE_SIZE_SELECTION_READ(x)  Asm("mrc p15, 2, %0, c0, c0, 0":"=r"(x))
#endif /* __TARGET_ARCH_ARM == 7 */

#define CPU15_PONLY_THREAD_ID_READ(x)  Asm("mrc p15, 0, %0, c13, c0, 4":"=r"(x))
#define CPU15_PONLY_THREAD_ID_WRITE(x) Asm("mcr p15, 0, %0, c13, c0, 4":: "r"(x)) 

/*
 *  ץΥӥå
 */
#define CP15_CONTROL_XP_BIT   (1 << 23)
#define CP15_CONTROL_I_BIT    (1 << 12)
#define CP15_CONTROL_C_BIT    (1 <<  2)
#define CP15_CONTROL_M_BIT    (1 <<  0)

#if __TARGET_ARCH_ARM == 6
#define CP15_AUXILIARY_SA_BIT (1 << 5)
#define CP15_CPUID_BIT        (0x0f)
#else /* __TARGET_ARCH_ARM == 7 */
#define CP15_AUXILIARY_SA_BIT (1 << 6)
#define CP15_AUXILIARY_EX_BIT (1 << 7)
#define CP15_CPUID_BIT        (0x03)
#endif /* __TARGET_ARCH_ARM == 7 */

#define CP15_TTB0_RGN_S       (1 << 1)
#define CP15_TTB0_RGN_WBWA    (1 << 3)

#if __TARGET_ARCH_ARM == 7
#define CP15_TTB0_IRGN_WBWA   ((1 << 6)|(0))
#endif /* __TARGET_ARCH_ARM == 7 */


/*
 *  ץѤ롼
 */

/*
 *  ץåINDEX0ꥸˤμ
 */
Inline uint32_t
x_prc_index(void)
{
	uint32_t index;

	CP15_CPUID_READ(index);
	return((index & 0x0fU));
}

/*
 *  Data Synchronization Barrier
 *  ȯԤ줿 read  write νλԤ
 *  å塤֥ץǥTLBνλԤ
 *  ̿θ˽񤫤줿̿ϼ¹Ԥʤ 
 */
Inline void
mpcore_data_sync_barrier(void)
{
	CP15_DATA_SYNC_BARRIER();
}

/*
 *  Data Memory Barrier
 *  ץεҤ˽äơ˽񤫤줿̿ǤΥꥢ
 *     λޤԤġ
 *
 */
Inline void
mpcore_data_memory_barrier(void)
{
	CP15_DATA_MEMORY_BARRIER();
}

/*
 *  TLB̵
 */
Inline void
mpcore_invalidate_unfied_tlb(void)
{
	CP15_DATA_SYNC_BARRIER();
}

/*
 *  Då̵
 */
Inline void
mpcore_dcache_invalidate(void)
{
#if __TARGET_ARCH_ARM == 6
	CP15_DCACHE_INVALIDATE();
#elif __TARGET_ARCH_ARM == 7
	uint32_t bits = 0;
	uint32_t ways = 0;
	uint32_t sets = 0;

	CP15_CACHE_SIZE_SELECTION_WRITE(0);
	CP15_PBUFFER_FLUSH();
	for (ways = 0; ways < 4; ways++){
		for (sets = 0; sets < 256; sets++){
			bits = ways << 30 | sets << 5;
			CP15_DCACHE_INVALIDATE(bits);
		}
	}
#endif /* __TARGET_ARCH_ARM == 7 */
}

/*
 *  DåΥ꡼̵
 */
Inline void
mpcore_dcache_clean_and_invalidate(void)
{
#if __TARGET_ARCH_ARM == 6
	CP15_DCACHE_CLEAN_AND_INVALIDATE();
#elif __TARGET_ARCH_ARM == 7
	uint32_t bits = 0;
	uint32_t  ways = 0;
	uint32_t sets = 0;

	CP15_CACHE_SIZE_SELECTION_WRITE(0);
	CP15_PBUFFER_FLUSH();
	for (ways = 0; ways < 4; ways++){
		for (sets = 0; sets < 256; sets++){
			bits = ways << 30 | sets << 5;
			CP15_DCACHE_CLEAN_AND_INVALIDATE(bits);
		}
	}
#endif /* __TARGET_ARCH_ARM == 7 */
}

/*
 *  Iå̵
 */
Inline void
mpcore_icache_invalidate(void)
{
	CP15_ICACHE_INVALIDATE();
}

/*
 *  ץեåХåե򥯥ꥢ
 */
Inline void
mpcore_pbuffer_flash(void)
{
	CP15_PBUFFER_FLUSH();
}

#endif /* TOPPERS_MACRO_ONLY */

/*
 *  ¢޴Ϣ
 */
#define MPCORE_TM_LR     (MPCORE_PMR_BASE + 0x0600)  /* ɥ쥸           */
#define MPCORE_TM_COUNT  (MPCORE_PMR_BASE + 0x0604)  /* 󥿡쥸       */
#define MPCORE_TM_CNT    (MPCORE_PMR_BASE + 0x0608)  /* ȥ쥸     */
#define MPCORE_TM_ISR    (MPCORE_PMR_BASE + 0x060C)  /* ߥơ쥸 */

#define MPCORE_TM_CNT_EN        0x1
#define MPCORE_TM_CNT_AR        0x2
#define MPCORE_TM_CNT_IEN       0x4
#define MPCORE_TM_CNT_PS_OFFSET   8

#define MPCORE_TM_ISR_SCBIT    0x01

/*
 *  Snoop Control Unit
 */
#define MPCORE_SCU_CTRL    (MPCORE_PMR_BASE + 0x0000)  /* ȥ쥸 */
#define MPCORE_SCU_CONFIG  (MPCORE_PMR_BASE + 0x0004)  /* ե졼쥸 */
#define MPCORE_SCU_CPUST   (MPCORE_PMR_BASE + 0x0008)  /* CPUơ */
#define MPCORE_SCU_IALL    (MPCORE_PMR_BASE + 0x000C)  /* Хåɥ */
#define MPCORE_SCU_PM_CTRL (MPCORE_PMR_BASE + 0x0010)  /* ѥեޥ󥹥˥쥸 */
#define MPCORE_SCU_PM_EVT0 (MPCORE_PMR_BASE + 0x0014)  /* ˥󥿥٥0 */
#define MPCORE_SCU_PM_EVT1 (MPCORE_PMR_BASE + 0x0018)  /* ˥󥿥٥1 */
#define MPCORE_SCU_PM_MN0  (MPCORE_PMR_BASE + 0x001C)  /* ˥0 */
#define MPCORE_SCU_PM_MN1  (MPCORE_PMR_BASE + 0x0020)  /* ˥1 */
#define MPCORE_SCU_PM_MN2  (MPCORE_PMR_BASE + 0x0024)  /* ˥2 */
#define MPCORE_SCU_PM_MN3  (MPCORE_PMR_BASE + 0x0028)  /* ˥3 */
#define MPCORE_SCU_PM_MN4  (MPCORE_PMR_BASE + 0x002C)  /* ˥4 */
#define MPCORE_SCU_PM_MN5  (MPCORE_PMR_BASE + 0x0030)  /* ˥5 */
#define MPCORE_SCU_PM_MN6  (MPCORE_PMR_BASE + 0x0034)  /* ˥6 */
#define MPCORE_SCU_PM_MN7  (MPCORE_PMR_BASE + 0x0038)  /* ˥7 */


#define MPCORE_SCU_CTRL_EN (1 << 0)   /* SCU֥͡ */

#define MPCORE_SCU_PM_CTRL_ENA  (1 << 0)    /* ѥեޥ󥹥˥ͭ */
#define MPCORE_SCU_PM_CTRL_RST  (1 << 1)    /* ѥեޥ󥹥˥ꥻå */

#define MPCORE_SCU_PM_EVT_CYC_COUNT0_4 (31 << 0) /* 륫Ȼ */

#define MPCORE_SCU_IALL_WAYS   (0x0000ffffU)

#ifndef TOPPERS_MACRO_ONLY

/*
 *  SCUν
 */
extern void scu_init(void);

#if __TARGET_ARCH_ARM == 6
/*
 * SCU󥿤νMN0ѡ
 */
extern void scu_counter_init(void);

/*
 * SCUޤΥꥻå
 */
Inline void
scu_counter_reset(void)
{
	sil_wrw_mem((void *)MPCORE_SCU_PM_CTRL,
			sil_rew_mem((void *)MPCORE_SCU_PM_CTRL) | MPCORE_SCU_PM_CTRL_RST);
}

/*
 * SCUޤθͤɤ
 */
Inline uint_t
scu_counter_get_current(void)
{
	return (sil_rew_mem((void *)MPCORE_SCU_PM_MN0));
}
#endif /* __TARGET_ARCH_ARM == 6 */
#endif /* TOPPERS_MACRO_ONLY */

/*
 *  Distributed Interrupt Controller CPU Interface
 *
 *  ͥ٤ϡ0x00xF 16ʳ
 *  0x0ǹͥ٤ǡ0xFͥ١
 */
#define DIC_CPUIF_CR   (MPCORE_PMR_BASE + 0x0100)  /* ȥ쥸 */
#define DIC_CPUIF_PMR  (MPCORE_PMR_BASE + 0x0104)  /* ͥ٥ޥ쥸 */
#define DIC_CPUIF_BPR  (MPCORE_PMR_BASE + 0x0108)  /* Хʥݥȥ쥸 */
#define DIC_CPUIF_IAR  (MPCORE_PMR_BASE + 0x010C)  /* Interrupt Acknowledge Register */
#define DIC_CPUIF_EOI  (MPCORE_PMR_BASE + 0x0110)  /* End of Interrupt Register */
#define DIC_CPUIF_RII  (MPCORE_PMR_BASE + 0x0114)  /* Running Interrupt Register */

#define DIC_CPUIF_CR_EN      0x01
#if __TARGET_ARCH_ARM == 6
#define DIC_CPUIF_PMR_OFFSET 0x04
#define DIC_CPUIF_BPR_ALL    0x03  /* ƤΥӥåȤͭ */
#define DIC_CPUIF_BPR_3      0x04  /* 3ӥåͭ        */
#define DIC_CPUIF_BPR_2      0x05  /* 2ӥåͭ        */
#define DIC_CPUIF_BPR_1      0x06  /* 1ӥåͭ        */
#elif __TARGET_ARCH_ARM == 7
#define DIC_CPUIF_PMR_OFFSET 0x03
#define DIC_CPUIF_BPR_ALL    0x00  /* ƤΥӥåȤͭ */
#define DIC_CPUIF_BPR_4      0x03  /* 4ӥåͭ        */
#define DIC_CPUIF_BPR_3      0x04  /* 3ӥåͭ        */
#define DIC_CPUIF_BPR_2      0x05  /* 2ӥåͭ        */
#define DIC_CPUIF_BPR_1      0x06  /* 1ӥåͭ        */
#endif /* __TARGET_ARCH_ARM == 7 */


/*
 *  Distributed Interrupt Controller
 */
#define DIC_CR     (MPCORE_PMR_BASE + 0x1000)  /* ȥ쥸 */
#define DIC_ICT    (MPCORE_PMR_BASE + 0x1004)  /* Interrupt Controller ץ쥸 */
#if __TARGET_ARCH_ARM == 7
#define DIC_IID    (MPCORE_PMR_BASE + 0x1008)  /* Distributor Implementer ID */
#define DIC_SEC    (MPCORE_PMR_BASE + 0x1080)  /* ߥƥ */
#endif /* __TARGET_ARCH_ARM == 7 */
#define DIC_SE     (MPCORE_PMR_BASE + 0x1100)  /* ߥ֥͡륻å   */
#define DIC_CE     (MPCORE_PMR_BASE + 0x1180)  /* ߥ֥͡륯ꥢ */
#define DIC_SP     (MPCORE_PMR_BASE + 0x1200)  /* ߥåȥڥǥ */
#define DIC_CP     (MPCORE_PMR_BASE + 0x1280)  /* ߥꥢڥǥ */
#define DIC_IPR    (MPCORE_PMR_BASE + 0x1400)  /* ͥ٥쥸 */
#define DIC_ITR    (MPCORE_PMR_BASE + 0x1800)  /* ߥåȥ쥸/CA9SPIåȥ쥸 */
#define DIC_ICR    (MPCORE_PMR_BASE + 0x1C00)  /* ߥե졼쥸 */
#define DIC_SIR    (MPCORE_PMR_BASE + 0x1F00)  /* եȥߥ쥸  */
#if __TARGET_ARCH_ARM == 7
#define DIC_PPIS   (MPCORE_PRM_BASE + 0x1D00)  /* PPIơ */
#define DIC_SPIS   (MPCORE_PRM_BASE + 0x1D04)  /* SPIơ */
#endif /* __TARGET_ARCH_ARM == 7 */

#define DIC_CR_ENABLE 0x01

/*
 *  Υץåλ
 */
#define DIC_ITR_CPU0  0x01
#define DIC_ITR_CPU1  0x02
#define DIC_ITR_CPU2  0x04
#define DIC_ITR_CPU3  0x08

#define DIC_SIR_CPU0  0x01
#define DIC_SIR_CPU1  0x02
#define DIC_SIR_CPU2  0x04
#define DIC_SIR_CPU3  0x08
#define DIC_SIR_CPUS  0x0f

#define DIC_SIR_CPU_OFFSET 16

/*
 *  ͥ
 */
#define DIC_MAX_PRIORITY  0x00
#if __TARGET_ARCH_ARM == 6
#define DIC_MIN_PRIORITY  0x0f
#elif __TARGET_ARCH_ARM == 7
#define DIC_MIN_PRIORITY  0x1f
#endif /* __TARGET_ARCH_ARM == 7 */

/*
 *  ե졼쥸
 */
#define DIC_ICR_EDGE     0x03   /* å */
#define DIC_ICR_LEVEL    0x01   /* ٥ */

/*
 *  DICǥݡȤƤ߿
 */
#define DIC_TMIN_INTNO      0U

#ifndef DIC_TMAX_INTNO
#define DIC_TMAX_INTNO    255U
#endif /* DIC_TMAX_INTNO */

#ifndef DIC_TNUM_INT
#define DIC_TNUM_INT      256U
#endif /* DIC_TNUM_INT */

/*
 *  Хߤγֹ
 */
#define TMIN_GLOBAL_INTNO   32U

/*
 * ֹ(DICǤֹ)
 */
#define DIC_IRQNO_IPI0     0
#define DIC_IRQNO_IPI1     1
#define DIC_IRQNO_TM      29

#ifndef TOPPERS_MACRO_ONLY
/*
 *  DIC CPU󥿥եϢΥɥ饤
 */
/*
 *  CPUγͥ٥ޥ
 */ 
Inline void
dic_cpu_set_priority(int pri)
{
	sil_wrw_mem((void *)DIC_CPUIF_PMR,
				(pri << DIC_CPUIF_PMR_OFFSET));
}

/*
 *  CPUγͥ٥ޥ
 */ 
Inline int
dic_cpu_current_priority(void)
{
	return (sil_rew_mem((void *)(DIC_CPUIF_PMR)) >>
			DIC_CPUIF_PMR_OFFSET);    
}

/*
 *  ߥϥɥνиɬפIRC
 */
Inline void
dic_cpu_end_int(uint8_t id)
{
	sil_wrw_mem((void *)(DIC_CPUIF_EOI), id);
}

/*
 *  DICΥץåγͥ٤ΤɤΥӥåȤѤ뤫
 */
Inline void
dic_cpu_set_bp(int mask_bit)
{
	sil_wrw_mem((void *)DIC_CPUIF_BPR, mask_bit);
}

/*
 *  CPU󥿥եν
 */
extern void dic_cpu_init(void);

/*
 *  CPU󥿥եνλ
 */
extern void dic_cpu_stop(void);

/*
 *  DIC DIS󥿥եϢΥɥ饤
 */

/*
 *  ߶ػ
 */
extern void dic_disable_int(uint8_t id);

/*
 *  ߵ
 */
extern void dic_enable_int(uint8_t id);

/*
 *  ߥڥǥ󥰥ꥢ
 */
extern void dic_clear_pending(uint8_t id);

/*
 *  ߥڥǥ󥰥å
 */
extern void dic_set_pending(uint8_t id);

/*
 *  ׵Υå
 */
extern bool_t dic_probe_int(uint8_t id);

/*
 *  Υå
 */
extern void dic_config(uint8_t id, uint8_t config);

/*
 *  ͥ٤Υå
 *  ɽϤ 
 */
extern void dic_set_priority(uint8_t id, int pri);

/*
 *  DICߥåȤ
 *  CPUORǻ  
 */
extern void dic_set_target(uint8_t id, uint8_t cpus);

/*
 *  DIC󥿥եν
 */
extern void dic_init(void);

/*
 *  DIC󥿥եνλ
 */
extern void dic_stop(void);

/*
 *  եȥߤȯ
 */
Inline void
dic_swi(int cpu, int id)
{
	CP15_DATA_SYNC_BARRIER();
	sil_wrw_mem((void *)DIC_SIR, (cpu << DIC_SIR_CPU_OFFSET)|id);
	CP15_DATA_SYNC_BARRIER();
}

/*
 *  SMP⡼ɤͭ
 */
extern void mpcore_smp_mode_enable(void);

/*
 *  MMUϢ
 */

/*
 * Ѵơ֥ؤ
 * va   : ۥɥ쥹
 * pa   : ʪɥ쥹
 * size :  
 * s    : ͭ
 * tex  : C BȤȤ߹碌Ѳ
 * ap   : 
 * c    : å
 * b    : Хåե
 */
typedef struct{
	uintptr_t   va;
	uintptr_t   pa;
	uint32_t    size;
	uint8_t     s;
	uint8_t     tex;
	uint8_t     ap;
	uint8_t     c;
	uint8_t     b;
}MEMORY_ATTRIBUTE;

/*
 *  MMUν
 */
extern void mpcore_mmu_init(void);

/*
 *  MMUˤΥޥåԥ
 */
extern void mmu_map_memory(MEMORY_ATTRIBUTE *m_attribute);

/*
 *  I/Dåξͭ
 */
extern void mpcore_cache_enable(void);

/*
 *  I/Dåξ̵
 */
extern void mpcore_cache_disable(void);

#endif /* TOPPERS_MACRO_ONLY */
#endif /* TOPPERS_MPCORE_H */
