/*
 *  TOPPERS Software
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *
 *  Copyright (C) 2005-2008 by TAKAGI Nobuhisa
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 */

/*!
 *  \file   toppers/debug.hpp
 *  \brief  ǥХåѥ饤֥˴ؤ
 */
#ifndef TOPPERS_DEBUG_HPP_
#define TOPPERS_DEBUG_HPP_

#include "toppers/config.hpp"
#include <iostream>
#if defined( _WIN32 ) || defined( __WIN32__ ) || defined( WIN32 )
#include <windows.h>
#include <sstream>
#endif

namespace toppers
{

  template < typename T >
  void trace( char const* str, const T& value )
  {
#if defined( _WIN32 ) || defined( __WIN32__ ) || defined( WIN32 )
    std::ostringstream ostr;
    ostr << str << value << '\n';
    ::OutputDebugString( ostr.str().c_str() );
#else
    std::cerr << str << value << std::endl;
#endif
  }

}

#if defined( _DEBUG ) || defined( __DEBUG ) || defined( DEBUG )
#define TOPPERS_TRACE( str, value )   ::toppers::trace( ( str ), ( value ) )
#else
#define TOPPERS_TRACE( str, value )   ( ( void )0 )
#endif

#endif  // ! TOPPERS_DEBUG_HPP_
